Skip to content
Start here

List Memberships

GET/memberships

List memberships of accounts the user can access.

Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Memberships WriteMemberships Read
Query ParametersExpand Collapse
account: optional object { name }
name: optional string

Account name

maxLength100
direction: optional "asc" or "desc"

Direction to order memberships.

One of the following:
"asc"
"desc"
name: optional string

Account name

maxLength100
order: optional "id" or "account.name" or "status"

Field to order memberships by.

One of the following:
"id"
"account.name"
"status"
page: optional number

Page number of paginated results.

minimum1
per_page: optional number

Number of memberships per page.

maximum50
minimum5
status: optional "accepted" or "pending" or "rejected"

Status of this membership.

One of the following:
"accepted"
"pending"
"rejected"
ReturnsExpand Collapse
IAMCollectionMembershipResponse = object { errors, messages, success, 2 more }
errors: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
messages: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
success: true

Whether the API call was successful.

result: optional array of Membership { id, account, api_access_enabled, 3 more }
id: optional string

Membership identifier tag.

maxLength32
account: optional Account { id, name, type, 3 more }
id: string

Identifier

maxLength32
minLength32
name: string

Account name

maxLength100
type: "standard" or "enterprise"
One of the following:
"standard"
"enterprise"
created_on: optional string

Timestamp for the creation of the account

formatdate-time
managed_by: optional object { parent_org_id, parent_org_name }

Parent container details

parent_org_id: optional string

ID of the parent Organization, if one exists

maxLength32
parent_org_name: optional string

Name of the parent Organization, if one exists

settings: optional object { abuse_contact_email, enforce_twofactor }

Account settings

abuse_contact_email: optional string

Sets an abuse contact email to notify for abuse reports.

enforce_twofactor: optional boolean

Indicates whether membership in this account requires that Two-Factor Authentication is enabled

api_access_enabled: optional boolean

Enterprise only. Indicates whether or not API access is enabled specifically for this user on a given account.

permissions: optional object { analytics, billing, cache_purge, 9 more }

All access permissions for the user at the account.

analytics: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
billing: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
cache_purge: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
dns: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
dns_records: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
lb: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
logs: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
organization: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
ssl: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
waf: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
zone_settings: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
zones: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
roles: optional array of string

List of role names the membership has for this account.

status: optional "accepted" or "pending" or "rejected"

Status of this membership.

One of the following:
"accepted"
"pending"
"rejected"
result_info: optional object { count, page, per_page, total_count }
count: optional number

Total number of results for the requested service

page: optional number

Current page within paginated list of results

per_page: optional number

Number of results per page of results

total_count: optional number

Total results available without any search parameters

IAMCollectionMembershipResponseWithPolicies = object { errors, messages, success, 2 more }
errors: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
messages: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
success: true

Whether the API call was successful.

result: optional array of object { id, account, api_access_enabled, 4 more }
id: optional string

Membership identifier tag.

maxLength32
account: optional Account { id, name, type, 3 more }
id: string

Identifier

maxLength32
minLength32
name: string

Account name

maxLength100
type: "standard" or "enterprise"
One of the following:
"standard"
"enterprise"
created_on: optional string

Timestamp for the creation of the account

formatdate-time
managed_by: optional object { parent_org_id, parent_org_name }

Parent container details

parent_org_id: optional string

ID of the parent Organization, if one exists

maxLength32
parent_org_name: optional string

Name of the parent Organization, if one exists

settings: optional object { abuse_contact_email, enforce_twofactor }

Account settings

abuse_contact_email: optional string

Sets an abuse contact email to notify for abuse reports.

enforce_twofactor: optional boolean

Indicates whether membership in this account requires that Two-Factor Authentication is enabled

api_access_enabled: optional boolean

Enterprise only. Indicates whether or not API access is enabled specifically for this user on a given account.

permissions: optional object { analytics, billing, cache_purge, 9 more }

All access permissions for the user at the account.

analytics: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
billing: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
cache_purge: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
dns: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
dns_records: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
lb: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
logs: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
organization: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
ssl: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
waf: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
zone_settings: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
zones: optional PermissionGrant { read, write }
read: optional boolean
write: optional boolean
policies: optional array of object { id, access, permission_groups, resource_groups }

Access policy for the membership

id: optional string

Policy identifier.

access: optional "allow" or "deny"

Allow or deny operations against the resources.

One of the following:
"allow"
"deny"
permission_groups: optional array of object { id, meta, name }

A set of permission groups that are specified to the policy.

id: string

Identifier of the permission group.

meta: optional object { key, value }

Attributes associated to the permission group.

key: optional string
value: optional string
name: optional string

Name of the permission group.

resource_groups: optional array of object { id, scope, meta, name }

A list of resource groups that the policy applies to.

id: string

Identifier of the resource group.

scope: array of object { key, objects }

The scope associated to the resource group

key: string

This is a combination of pre-defined resource name and identifier (like Account ID etc.)

objects: array of object { key }

A list of scope objects for additional context.

key: string

This is a combination of pre-defined resource name and identifier (like Zone ID etc.)

meta: optional object { key, value }

Attributes associated to the resource group.

key: optional string
value: optional string
name: optional string

Name of the resource group.

roles: optional array of string

List of role names the membership has for this account.

status: optional "accepted" or "pending" or "rejected"

Status of this membership.

One of the following:
"accepted"
"pending"
"rejected"
result_info: optional object { count, page, per_page, total_count }
count: optional number

Total number of results for the requested service

page: optional number

Current page within paginated list of results

per_page: optional number

Number of results per page of results

total_count: optional number

Total results available without any search parameters

List Memberships

curl https://api.cloudflare.com/client/v4/memberships \
    -H "X-Auth-Email: $CLOUDFLARE_EMAIL" \
    -H "X-Auth-Key: $CLOUDFLARE_API_KEY"
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "4536bcfad5faccb111b47003c79917fa",
      "account": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "name": "Demo Account",
        "type": "standard",
        "created_on": "2014-03-01T12:21:02.0000Z",
        "managed_by": {
          "parent_org_id": "4536bcfad5faccb111b47003c79917fa",
          "parent_org_name": "Demo Parent Organization"
        },
        "settings": {
          "abuse_contact_email": "abuse_contact_email",
          "enforce_twofactor": true
        }
      },
      "api_access_enabled": true,
      "permissions": {
        "analytics": {
          "read": true,
          "write": false
        },
        "billing": {
          "read": true,
          "write": false
        },
        "cache_purge": {
          "read": true,
          "write": false
        },
        "dns": {
          "read": true,
          "write": false
        },
        "dns_records": {
          "read": true,
          "write": false
        },
        "lb": {
          "read": true,
          "write": false
        },
        "logs": {
          "read": true,
          "write": false
        },
        "organization": {
          "read": true,
          "write": false
        },
        "ssl": {
          "read": true,
          "write": false
        },
        "waf": {
          "read": true,
          "write": false
        },
        "zone_settings": {
          "read": true,
          "write": false
        },
        "zones": {
          "read": true,
          "write": true
        }
      },
      "roles": [
        "Account Administrator"
      ],
      "status": "accepted"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "4536bcfad5faccb111b47003c79917fa",
      "account": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "name": "Demo Account",
        "type": "standard",
        "created_on": "2014-03-01T12:21:02.0000Z",
        "managed_by": {
          "parent_org_id": "4536bcfad5faccb111b47003c79917fa",
          "parent_org_name": "Demo Parent Organization"
        },
        "settings": {
          "abuse_contact_email": "abuse_contact_email",
          "enforce_twofactor": true
        }
      },
      "api_access_enabled": true,
      "permissions": {
        "analytics": {
          "read": true,
          "write": false
        },
        "billing": {
          "read": true,
          "write": false
        },
        "cache_purge": {
          "read": true,
          "write": false
        },
        "dns": {
          "read": true,
          "write": false
        },
        "dns_records": {
          "read": true,
          "write": false
        },
        "lb": {
          "read": true,
          "write": false
        },
        "logs": {
          "read": true,
          "write": false
        },
        "organization": {
          "read": true,
          "write": false
        },
        "ssl": {
          "read": true,
          "write": false
        },
        "waf": {
          "read": true,
          "write": false
        },
        "zone_settings": {
          "read": true,
          "write": false
        },
        "zones": {
          "read": true,
          "write": true
        }
      },
      "roles": [
        "Account Administrator"
      ],
      "status": "accepted"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}